# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ....core.datetime_utils import serialize_datetime
from .google_chronicle_credential import GoogleChronicleCredential

try:
    import pydantic.v1 as pydantic  # type: ignore
except ImportError:
    import pydantic  # type: ignore


class SinkGoogleSecOps(pydantic.BaseModel):
    """
    Configuration for Google Security Operations (formerly Google Chronicle) as a Sink Provider.
    """

    credential: GoogleChronicleCredential = pydantic.Field()
    """
    The credential set used to write events to Google SecOps.
    """

    customer_id: str = pydantic.Field()
    """
    The customer ID reported when writing events.
    """

    url: typing.Optional[str] = pydantic.Field(default=None)
    """
    (Optional) Ingestion URL for the Google SecOps instance. This should be the base event ingestion URL, without any path components.
    """

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        extra = pydantic.Extra.allow
        json_encoders = {dt.datetime: serialize_datetime}
